import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;

import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreNotFoundException;

import lib.Utils.Utils;
import Mail.Message;

public class Database{
	//  
	String 	adrBookUserName,
			adrBookUserEMail;
	//  
	String 	mailboxName,
			userName,
			userEMail,
			inboxServer,
			inboxUserName,
			inboxPass,
			smtpServer,
			smtpUserName,
			smtpPass;
	
	long	lastSize = 0;
			
	int inboxPort,
		smtpPort;

	boolean 	useSMTPAuth = true,
				useSMTPAuthFromPOP = false,
				usePOP = true,
				deleteMailsFromServer = false,
				saveInboxMessages = true,
				antispam = true,
				inboxSSL = true,
				smtpSSL = true;
	
	int[] 	mailboxesidxarray,
			usersidxarray,
			mailsidxarray = new int[0];
	
	//  
	boolean smiles = true,
			showSubject = true,
			showFrom = true,
			showTo = true,
			showDate = true,
			showSize = true,
			showMailer = true;

	int userId = 0,
		fontsize = 8,
		height_diff = 0;


	private final static String STORE_CONFIG  = "settings";
	private final static String STORE_MAILBOX = "mailboxes";
	private final static String STORE_ADRBOOK = "adrbook";
	
	public Database() {
	}

	public void load() {
		DataInputStream din;
		try {
			RecordStore rs = RecordStore.openRecordStore(STORE_CONFIG, true);

			int size = rs.getNumRecords();
			String version;

			try {
				byte[] temp = rs.getRecord(1);
				version = (new DataInputStream(new ByteArrayInputStream(temp))).readUTF();
			} catch (Exception e) {version = "";}

			if (!version.equals(Main.VERSION)) {
				rs.closeRecordStore();
				try {
					RecordStore.deleteRecordStore(STORE_CONFIG);
					//RecordStore.deleteRecordStore(STORE_MAILBOX);
					//RecordStore.deleteRecordStore(STORE_ADRBOOK);
				} catch (Exception e) {}

				rs = RecordStore.openRecordStore(STORE_CONFIG, true);

				byte[] temp;
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				DataOutputStream dos = new DataOutputStream(baos);
				dos.writeUTF(Main.VERSION);
				temp = baos.toByteArray();
				dos.close();

				rs.addRecord(temp, 0, temp.length);
				temp = new byte[0];
				rs.addRecord(temp, 0, temp.length);
				rs.addRecord(temp, 0, temp.length);
				rs.addRecord(temp, 0, temp.length);
				rs.addRecord(temp, 0, temp.length);
				rs.addRecord(temp, 0, temp.length);

				saveMailBox();
				saveUserFromAdrBook();
				saveAdvanced();
			}
			else {
				din = new DataInputStream(new ByteArrayInputStream(rs.getRecord(4)));

				smiles = din.readBoolean();
				
				showSubject = din.readBoolean();
				showFrom = din.readBoolean();
				showTo = din.readBoolean();
				showDate = din.readBoolean();
				showSize = din.readBoolean();
				showMailer = din.readBoolean();
				
				userId = din.readInt();
				fontsize = din.readInt();
				height_diff = din.readInt();
				
				din.close();
			}
			rs.closeRecordStore();
		}
		catch(Exception e){}
	}
//	======== =====================	
	public String[] getMailBoxes() {
		String[] ret = null;

		try {
			byte[] temp;
			DataInputStream din;
			RecordStore rs = RecordStore.openRecordStore(STORE_MAILBOX, true);

			if (rs.getNumRecords() == 0) {
				rs.addRecord(new byte[4], 0, 4);
				mailboxesidxarray = new int[0];
				ret = new String[0];
			}
			else {
				din = new DataInputStream(new ByteArrayInputStream(rs.getRecord(1)));
				rs.closeRecordStore();

				int mailBoxes = din.readInt();
				ret = new String[mailBoxes];
				mailboxesidxarray = new int[mailBoxes];

				for (int i=0; i<ret.length; i++) {
					ret[i] = din.readUTF();
					mailboxesidxarray[i] = din.readInt();
				}
				din.close();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return ret;
	}
	public void setMailBox(int index) {
		if (index < mailboxesidxarray.length) {
			try {
				int rsidx = mailboxesidxarray[index];
				RecordStore rs = RecordStore.openRecordStore(STORE_MAILBOX, false);
				if (rsidx > 0) {
					DataInputStream dis = new DataInputStream(new ByteArrayInputStream(rs.getRecord(rsidx)));

					mailboxName = dis.readUTF();
					userName = dis.readUTF();
					userEMail = dis.readUTF();
					
					inboxServer = dis.readUTF();
					inboxPort = dis.readInt();
					inboxUserName = dis.readUTF();
					inboxPass = dis.readUTF();
					
					usePOP = dis.readBoolean();
					
					smtpServer = dis.readUTF();
					smtpPort = dis.readInt();
					smtpUserName = dis.readUTF();
					smtpPass = dis.readUTF();
					
					useSMTPAuth = dis.readBoolean();
					useSMTPAuthFromPOP = dis.readBoolean();
					deleteMailsFromServer = dis.readBoolean();
					saveInboxMessages = dis.readBoolean();
					antispam = dis.readBoolean();
					inboxSSL = dis.readBoolean();
					smtpSSL = dis.readBoolean();
					
					lastSize = dis.readLong();
					
				}
				rs.closeRecordStore();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	public void addMailBox() {
		editMailBox(mailboxesidxarray.length);
	}
	public void editMailBox(int index) {
		try {
			ByteArrayOutputStream baos;
			DataOutputStream dos;

			RecordStore rs = RecordStore.openRecordStore(STORE_MAILBOX, false);
			editMailBoxName(rs, index, mailboxName);

			baos = new ByteArrayOutputStream();
			dos = new DataOutputStream(baos);
			dos.writeUTF(mailboxName);
			dos.writeUTF(userName);
			dos.writeUTF(userEMail);
			
			dos.writeUTF(inboxServer);
			dos.writeInt(inboxPort);
			dos.writeUTF(inboxUserName);
			dos.writeUTF(inboxPass);
			
			dos.writeBoolean(usePOP);

			dos.writeUTF(smtpServer);
			dos.writeInt(smtpPort);
			dos.writeUTF(smtpUserName);
			dos.writeUTF(smtpPass);
			
			dos.writeBoolean(useSMTPAuth);
			dos.writeBoolean(useSMTPAuthFromPOP);
			dos.writeBoolean(deleteMailsFromServer);
			dos.writeBoolean(saveInboxMessages);
			dos.writeBoolean(antispam);
			dos.writeBoolean(inboxSSL);
			dos.writeBoolean(smtpSSL);
			
			dos.writeLong(lastSize);
			
			byte[] temp = baos.toByteArray();
			dos.close();

			rs.setRecord(mailboxesidxarray[index], temp, 0, temp.length);
			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	public void deleteMailBox(int index) {
		try {
			RecordStore rs = RecordStore.openRecordStore(STORE_MAILBOX, false);

			rs.deleteRecord(mailboxesidxarray[index]);
			editMailBoxName(rs, index, null); // delete profile name

			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	private void editMailBoxName(RecordStore rs, int idx, String newname) throws Exception {
		int i, mailBoxes;
		DataInputStream dis;
		DataOutputStream dos;
		ByteArrayOutputStream baos;
		boolean createnew = false;

		byte[] temp = rs.getRecord(1);
		dis = new DataInputStream(new ByteArrayInputStream(temp));
		baos = new ByteArrayOutputStream();
		dos = new DataOutputStream(baos);

		mailBoxes = dis.readInt();
		if (newname == null && idx >= 0 && idx < mailBoxes) {
			// if we delete a profile then decrease the mailboxesidxarray size
			mailBoxes--;;
			mailboxesidxarray = new int[mailBoxes];
		}
		else if (idx < 0 || idx >= mailBoxes) {
			// create a new profile
			mailBoxes++;
			mailboxesidxarray = new int[mailBoxes];
			createnew = true;
		}
		else if (newname == null) {
			// can't delete a profile that doesn't exist
			return;
		}
		dos.writeInt(mailBoxes);

		for (i=0; i<mailBoxes; i++) {
			if (i == mailBoxes-1 && createnew) break;

			if (i == idx) {
				if (newname != null) {
					dis.readUTF();
					dos.writeUTF(newname);
					mailboxesidxarray[i] = dis.readInt();
					dos.writeInt(mailboxesidxarray[i]);
					continue;
				}
				else {
					dis.readUTF();
					dis.readInt();
				}
			}
			dos.writeUTF(dis.readUTF());
			mailboxesidxarray[i] = dis.readInt();
			dos.writeInt(mailboxesidxarray[i]);
		}
		if (createnew) {
			// add a new profile to the end
			dos.writeUTF(newname);
			mailboxesidxarray[i] = rs.getNextRecordID();
			dos.writeInt(mailboxesidxarray[i]);

			// also add the empty record for it
			rs.addRecord(new byte[0], 0, 0);
		}

		temp = baos.toByteArray();
		dis.close();
		dos.close();
		rs.setRecord(1, temp, 0, temp.length);
	}
	public void saveMailBox() {
		try{
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			DataOutputStream dos = new DataOutputStream(baos);
			byte[] byteout;

			byteout = baos.toByteArray();
			dos.close();
			baos.close();

			RecordStore rs = RecordStore.openRecordStore(STORE_CONFIG, true);
			rs.setRecord(2, byteout, 0, byteout.length);
			rs.closeRecordStore();
		}
		catch(Exception e) {
			e.printStackTrace();
			// error in saving settings, should handle this
		}
	}
//	======== =====================	
	public String[] getUsersFromAdrBook() {
		String[] ret = null;

		try {
			byte[] temp;
			DataInputStream din;
			RecordStore rs = RecordStore.openRecordStore(STORE_ADRBOOK, true);

			if (rs.getNumRecords() == 0) {
				rs.addRecord(new byte[4], 0, 4);
				usersidxarray = new int[0];
				ret = new String[0];
			}
			else {
				din = new DataInputStream(new ByteArrayInputStream(rs.getRecord(1)));
				rs.closeRecordStore();

				int users = din.readInt();
				ret = new String[users];
				usersidxarray = new int[users];

				for (int i=0; i<ret.length; i++) {
					ret[i] = din.readUTF();
					usersidxarray[i] = din.readInt();
				}
				din.close();
			}
		} catch (Exception e) {}

		return ret;
	}
	public void setUserFromAdrBook(int index) {
		if (index < usersidxarray.length) {
			try {
				int rsidx = usersidxarray[index];
				RecordStore rs = RecordStore.openRecordStore(STORE_ADRBOOK, false);
				if (rsidx > 0) {
					DataInputStream dis = new DataInputStream(new ByteArrayInputStream(rs.getRecord(rsidx)));

					adrBookUserName = dis.readUTF();
					adrBookUserEMail = dis.readUTF();
					
				}
				rs.closeRecordStore();
			} catch (Exception e) {}
		}
	}
	public void addUserToAdrBook() {
		editUserFromAdrBook(usersidxarray.length);
	}
	public void editUserFromAdrBook(int index) {
		try {
			ByteArrayOutputStream baos;
			DataOutputStream dos;

			RecordStore rs = RecordStore.openRecordStore(STORE_ADRBOOK, false);
			editUserFromAdrBookName(rs, index, adrBookUserName);

			baos = new ByteArrayOutputStream();
			dos = new DataOutputStream(baos);

			dos.writeUTF(adrBookUserName);
			dos.writeUTF(adrBookUserEMail);

			byte[] temp = baos.toByteArray();
			dos.close();

			rs.setRecord(usersidxarray[index], temp, 0, temp.length);
			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	public void deleteUserFromAdrBook(int index) {
		try {
			RecordStore rs = RecordStore.openRecordStore(STORE_ADRBOOK, false);

			rs.deleteRecord(usersidxarray[index]);
			editUserFromAdrBookName(rs, index, null); // delete profile name

			rs.closeRecordStore();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	private void editUserFromAdrBookName(RecordStore rs, int idx, String newname) throws Exception {
		int i, mailBoxes;
		DataInputStream dis;
		DataOutputStream dos;
		ByteArrayOutputStream baos;
		boolean createnew = false;

		byte[] temp = rs.getRecord(1);
		dis = new DataInputStream(new ByteArrayInputStream(temp));
		baos = new ByteArrayOutputStream();
		dos = new DataOutputStream(baos);

		mailBoxes = dis.readInt();
		if (newname == null && idx >= 0 && idx < mailBoxes) {
			// if we delete a profile then decrease the usersidxarray size
			mailBoxes--;;
			usersidxarray = new int[mailBoxes];
		}
		else if (idx < 0 || idx >= mailBoxes) {
			// create a new profile
			mailBoxes++;
			usersidxarray = new int[mailBoxes];
			createnew = true;
		}
		else if (newname == null) {
			// can't delete a profile that doesn't exist
			return;
		}
		dos.writeInt(mailBoxes);

		for (i=0; i<mailBoxes; i++) {
			if (i == mailBoxes-1 && createnew) break;

			if (i == idx) {
				if (newname != null) {
					dis.readUTF();
					dos.writeUTF(newname);
					usersidxarray[i] = dis.readInt();
					dos.writeInt(usersidxarray[i]);
					continue;
				}
				else {
					dis.readUTF();
					dis.readInt();
				}
			}
			dos.writeUTF(dis.readUTF());
			usersidxarray[i] = dis.readInt();
			dos.writeInt(usersidxarray[i]);
		}
		if (createnew) {
			// add a new profile to the end
			dos.writeUTF(newname);
			usersidxarray[i] = rs.getNextRecordID();
			dos.writeInt(usersidxarray[i]);

			// also add the empty record for it
			rs.addRecord(new byte[0], 0, 0);
		}

		temp = baos.toByteArray();
		dis.close();
		dos.close();
		rs.setRecord(1, temp, 0, temp.length);
	}
	public void saveUserFromAdrBook() {
		try{
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			DataOutputStream dos = new DataOutputStream(baos);
			byte[] byteout;

			byteout = baos.toByteArray();
			dos.close();
			baos.close();

			RecordStore rs = RecordStore.openRecordStore(STORE_CONFIG, true);
			rs.setRecord(3, byteout, 0, byteout.length);
			rs.closeRecordStore();
		}
		catch(Exception e) {}
	}
//	========= ====================	
	public void saveAdvanced() {
		try {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			DataOutputStream dos = new DataOutputStream(baos);
			byte[] byteout;

			dos.writeBoolean(smiles);

			dos.writeBoolean(showSubject);
			dos.writeBoolean(showFrom);
			dos.writeBoolean(showTo);
			dos.writeBoolean(showDate);
			dos.writeBoolean(showSize);
			dos.writeBoolean(showMailer);
			
			dos.writeInt(userId);
			dos.writeInt(fontsize);
			dos.writeInt(height_diff);

			byteout = baos.toByteArray();
			dos.close();
			baos.close();

			RecordStore rs = RecordStore.openRecordStore(STORE_CONFIG, true);
			rs.setRecord(4, byteout, 0, byteout.length);
			rs.closeRecordStore();
		}
		catch(Exception e) {}
	}
//	==========(, , )===================	
	public String[] getMailsIDs(String folderName) {
		String[] ret = null;
		try {
			byte[] temp;
			DataInputStream din;
			RecordStore rs = RecordStore.openRecordStore(folderName, true);

			if (rs.getNumRecords() == 0) {
				rs.addRecord(new byte[4], 0, 4);
				mailsidxarray = new int[0];
				ret = new String[0];
			}else {
				din = new DataInputStream(new ByteArrayInputStream(rs.getRecord(1)));
				rs.closeRecordStore();

				int mails = din.readInt();
				ret = new String[mails];
				mailsidxarray = new int[mails];

				for (int i=0; i<ret.length; i++){
					ret[i] 				= din.readUTF();
					mailsidxarray[i] 	= din.readInt();
				}
				din.close();
			}
		} catch (Exception e) {}

		return ret;
	}
	public int getMailNumByID(String folderName, String uniqueId){
		String[] IDs = getMailsIDs(folderName);
		for(int i=0; i<IDs.length; i++){
			if(IDs[i].equals(uniqueId))
				return i;
		}
		return -1;
	}
	public Message getMail(String folderName, int index) {
		System.out.println("= getMail0 "+index);
		Message mes = new Message();
		if (index < mailsidxarray.length) {
			try {
				int rsidx = mailsidxarray[index];
				RecordStore rs = RecordStore.openRecordStore(folderName, false);
				if (rsidx > 0) {
					DataInputStream dis = new DataInputStream(new ByteArrayInputStream(rs.getRecord(rsidx)));

					mes.size = dis.readUTF();	
					int headerSize 	= dis.readInt(),
						bodySize 	= dis.readInt();
					
					for(int i=0; i<headerSize; i++)
						mes.addHeaderLine(dis.readUTF());
					for(int i=0; i<bodySize; i++)
						mes.addBodyLine(dis.readUTF());
				}
				rs.closeRecordStore();
			} catch (Exception e) {}
		}
		return mes;
	}
	public Message getMail(String folderName, int index, int linesCount) {
		System.out.println("= getMail "+index);
		Message mes = new Message();
		if (index < mailsidxarray.length) {
			try {
				int rsidx = mailsidxarray[index];
				RecordStore rs = RecordStore.openRecordStore(folderName, false);
				if (rsidx > 0) {
					DataInputStream dis = new DataInputStream(new ByteArrayInputStream(rs.getRecord(rsidx)));


					mes.size = dis.readUTF();	
					int headerSize 	= dis.readInt(),
						bodySize 	= dis.readInt();
					
					if(linesCount<bodySize) bodySize=linesCount;
					
					for(int i=0; i<headerSize; i++)
						mes.addHeaderLine(dis.readUTF());
					for(int i=0; i<bodySize; i++)
						mes.addBodyLine(dis.readUTF());
				}
				rs.closeRecordStore();
			} catch (Exception e) {e.printStackTrace();}
		}
		return mes;
	}
	public void addMail(String folderName, Message mes, String uniqueId) {
		editMail(folderName, mes, mailsidxarray.length, uniqueId);
	}
	public void editMail(String folderName, Message mes, int index, String uniqueId) {
		try {
			ByteArrayOutputStream baos;
			DataOutputStream dos;

			RecordStore rs = RecordStore.openRecordStore(folderName, false);
			editMailID(rs, index, uniqueId);


			baos = new ByteArrayOutputStream();
			dos = new DataOutputStream(baos);

			int headerSize 	= mes.getHeaderLineCount(),
				bodySize 	= mes.getBodyLineCount();
			
			dos.writeUTF(mes.size);
			dos.writeInt(headerSize);
			dos.writeInt(bodySize);
			for(int i=0; i<headerSize; i++){
//				System.out.println(Utils.replace(mes.getHeaderLine(i),"\u00AC","|#|"));
				dos.writeUTF(Utils.replace(mes.getHeaderLine(i),"\u00AC"," "));
				System.out.println(Utils.replace(mes.getHeaderLine(i),"\u00AC"," "));
			}
			for(int i=0; i<bodySize; i++){
				dos.writeUTF(Utils.replace(mes.getBodyLine(i),"\u00AC"," "));
				System.out.println(Utils.replace(mes.getBodyLine(i),"\u00AC"," "));
			}
			byte[] temp = baos.toByteArray();
			dos.close();

			rs.setRecord(mailsidxarray[index], temp, 0, temp.length);
			rs.closeRecordStore();
		} catch (Exception e){
		}
	}
	public void deleteMail(String folderName, int index) {
		boolean createnew = false;

		try {
			RecordStore rs = RecordStore.openRecordStore(folderName, false);

			rs.deleteRecord(mailsidxarray[index]);
			editMailID(rs, index, null);

			rs.closeRecordStore();
		} catch (Exception e) {}
	}
	private void editMailID(RecordStore rs, int idx, String newID) throws Exception {
		int i, mails;
		DataInputStream dis;
		DataOutputStream dos;
		ByteArrayOutputStream baos;
		boolean createnew = false;

		byte[] temp = rs.getRecord(1);
		dis = new DataInputStream(new ByteArrayInputStream(temp));
		baos = new ByteArrayOutputStream();
		dos = new DataOutputStream(baos);

		mails = dis.readInt();
		if (newID == null && idx >= 0 && idx < mails) {
			mails--;
			mailsidxarray = new int[mails];
		}else if (idx < 0 || idx >= mails) {
			mails++;
			mailsidxarray = new int[mails];
			createnew = true;
		}else if (newID == null) {
			return;
		}
		dos.writeInt(mails);

		for (i=0; i<mails; i++) {
			if (i == mails-1 && createnew) break;

			if (i == idx) {
				if (newID != null) {
					dis.readUTF();
					dos.writeUTF(newID);
					mailsidxarray[i] = dis.readInt();
					dos.writeInt(mailsidxarray[i]);
					continue;
				}else{
					dis.readUTF();
					dis.readInt();
				}
			}
			dos.writeUTF(dis.readUTF());
			mailsidxarray[i] = dis.readInt();
			dos.writeInt(mailsidxarray[i]);
		}
		if (createnew) {
			dos.writeUTF(newID);
			mailsidxarray[i] = rs.getNextRecordID();
			dos.writeInt(mailsidxarray[i]);

			rs.addRecord(new byte[0], 0, 0);
		}

		temp = baos.toByteArray();
		dis.close();
		dos.close();
		rs.setRecord(1, temp, 0, temp.length);
	}
	public void deleteFolder(String folderName){
		try {
			RecordStore.deleteRecordStore(folderName);
		} catch (RecordStoreNotFoundException e) {
		} catch (RecordStoreException e) {
		}
	}
}
