package Mail;

import java.util.Vector;

public class Envelope {
    
    private Message message;
    
    private String sender;
    
    private Vector recipients;
    
    public Envelope(Message message, boolean autofill) {
        this.message = message;
        recipients = new Vector();
        
        if (autofill) {
            sender = message.getHeaderValue("From");
            
            String[] toFields = message.getAllHeaderValues("To");
            for (int i = 0; i < toFields.length; i++) {
                recipients.addElement(toFields[i]);
            }
            
            String[] ccFields = message.getAllHeaderValues("CC");
            for (int i = 0; i < ccFields.length; i++) {
                recipients.addElement(ccFields[i]);
            }
            
            String[] bccFields = message.getAllHeaderValues("Bcc");
            for (int i = 0; i < bccFields.length; i++) {
                recipients.addElement(bccFields[i]);
            }
        }
    }
    
    public Message getMessage() {
        return message;
    }
    
    public void setSender(String address) {
        sender = address;
    }
    
    public String getSender() {
        return sender;
    }
    
    public int addRecipient(String address) {
        recipients.addElement(address);
        return recipients.size() - 1;
    }
    
    public void setRecipient(int index, String address) throws ArrayIndexOutOfBoundsException {
        recipients.setElementAt(address, index);
    }
    
    public int getRecipientCount() {
        return recipients.size();
    }
    
    public String getRecipient(int index) throws ArrayIndexOutOfBoundsException {
        return (String)recipients.elementAt(index);
    }
    
    public void removeRecipient(int index) throws ArrayIndexOutOfBoundsException {
        recipients.removeElementAt(index);
    }
}