package Mail;

import java.io.IOException;

public abstract class InboxClient {

    protected Connection connection;
    private boolean debug;
    
    protected InboxClient(Connection connection) {
        if (connection == null) connection = new Connection();
        this.connection = connection;
    }

    public abstract void open(String host, int port, String user, String pass, boolean ssl) throws Exception, IOException, MailException;

    public abstract void close() throws IOException, MailException;

    public boolean connected() {
        return connection.connected();
    }

    public abstract int getMessageCount() throws IOException, MailException;

    public abstract Message getMessage(int index) throws IOException, MailException;

    public abstract Message getHeaders(int index) throws IOException, MailException;

    public abstract String getUniqueId(int index) throws IOException, MailException;

    public abstract int getSize(int index) throws IOException, MailException;

    public abstract void removeMessage(int index) throws IOException, MailException;

    public void setDebug(boolean debug) {
        connection.setDebug(debug);
    }

    public boolean getDebug() {
        return connection.getDebug();
    }
}
