import java.io.IOException;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemStateListener;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import lib.GraphicControls.Emotions;
import lib.GraphicControls.MessageBox;
import lib.GraphicControls.Page;
import lib.GraphicControls.PageControl;
import lib.GraphicControls.PageControlCommandListener;
import lib.GraphicControls.SplashScreen;
import lib.GraphicControls.SplashScreenCommandListener;
import lib.Resources.ImageList;
import lib.Utils.Utils;
import Mail.Connection;
import Mail.Decoder;
import Mail.ImapClient;
import Mail.MailException;
import Mail.Message;
import Mail.MimeDecoder;
import Mail.Pop3Client;
import Mail.SmtpClient;

public class Main  extends MIDlet implements CommandListener, ItemStateListener, PageControlCommandListener, SplashScreenCommandListener{
	public static final String VERSION = "0.2";
	private List 	menuList,
					mailBoxesList,
					mailBoxOptions,
					adrBookList,
					adrBookOptions,
					inboxMenu,
					outboxMenu,
					sentMenu,
					messageMenu;
	private Display display;
	private PageControl pc;
	private SplashScreen ss;
	private MessageBox mb;
	private Database db;
	private Displayable lastDisplay = null;
	private ImageList 	icons,
						folders,
						smiles;
	private Emotions emotions;
	private ChoiceGroup cg_fontsize,
						cg_misc,
						cg_showedItems,
						cg_inboxType,
						cg_SMTPAuthSettings,
						cg_mailBoxSettings,
						cg_addressOptions,
						cg_inboxSSL,
						cg_smtpSSL;
	private TextField 	tf_heightdiff,
						tf_mailBoxName,
						tf_mailBoxUserName,
						tf_mailBoxUserEMail,
						tf_mailBoxInboxServer,
						tf_mailBoxInboxPort,
						tf_mailBoxInboxUserName,
						tf_mailBoxInboxPass,
						tf_mailBoxSMTPServer,
						tf_mailBoxSMTPPort,
						tf_mailBoxSMTPUserName,
						tf_mailBoxSMTPPass,
						tf_adrBookUserName,
						tf_adrBookUserEMail,
						tf_topic,
						tf_email,
						tf_messageText;
	private Form 	settingsForm,
					mailBoxSettings,
					adrBookrecordSettings,
					mailEditForm;
	private StringItem si_from;
	private Command cmd_back,
					cmd_menu,
					cmd_done,
					cmd_cancel,
					cmd_send,
					cmd_save,
					cmd_saveAndSend;
	private TextBox textbox;
	private boolean edited = false,
					addAddressMode = false,
					backToAdrBookList = false;
	private MailClient mailclient;
	public int 	bytesIn = 0,
				bytesOut = 0;
	private String servList[];

//	==========   // =========================
	private class MailClient extends Thread{
		private ImapClient imap;
		private Pop3Client pop;
		private SmtpClient smtp;
		private String 	host,
						login,
						pass,
						inboxFolder,
						outboxFolder,
						sentFolder;
		private int port;
		private boolean running = false;
		private Connection con;
		private Message message;
		private int inboxSize;
		private String[] mailsIDsInDB;
		private boolean ssl = false;
		
		public MailClient(boolean usePOP, String host, int port, String login, String pass, boolean ssl){
			this.host = host;
			this.port = port;
			this.login = login;
			this.pass = pass;
			this.ssl = ssl;
			
			con = new Connection();
			
			pop = null;
			smtp = null;
			imap = null;
			if(usePOP) pop = new Pop3Client(con);
			else imap = new ImapClient(con);

			inboxFolder 	= "inbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			outboxFolder 	= "outbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			sentFolder 		= "sent-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
		}

		public MailClient(String host, int port, String login, String pass, Message mes, boolean ssl){
			this.host = host;
			this.port = port;
			this.login = login;
			this.pass = pass;
			this.message = mes;
			this.ssl = ssl;

			con = new Connection();
			
			pop = null;
			imap = null;
			smtp = new SmtpClient(con);

			inboxFolder 	= "inbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			outboxFolder 	= "outbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			sentFolder 		= "sent-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
		}
		public MailClient(){
			inboxFolder 	= "inbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			outboxFolder 	= "outbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			sentFolder 		= "sent-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());

			pop = null;
			smtp = null;
			imap = null;
		}
		
		public void run(){
			display.setCurrent(ss);
			reSetPC();

//	=====================================
			if(smtp==null){
			ss.addLoadingString(". .   ");
			loadAndAddMailsListFromDB(inboxFolder, pc.getPage(0), "");

			ss.addLoadingString(". .   ");
			loadAndAddMailsListFromDB(outboxFolder, pc.getPage(1), "");
			
			ss.addLoadingString(". .   ");
			loadAndAddMailsListFromDB(sentFolder, pc.getPage(2), "");
			
			pc.updateBody();
			pc.updateHeader();
			}
//	=====================================			
			running = true;
			int length, startNum=0;
			long lastSize;
			
			try {
				if(pop != null){
					ss.addLoadingString(".  .");
					pop.open(host, port, login, pass, ssl);
					
					ss.addLoadingString(".  ");
					lastSize = pop.getMessagesSize();
					
					length = pop.getMessageCount();
					
					servList = new String[length];
					mailsIDsInDB = db.getMailsIDs(inboxFolder);
					
					ss.addLoadingString("0 %");
					for(int i=0; i<length && running; i++){
						ss.setLoadingString(((i*100)/length)+" %");
						try{
							servList[i] = pop.getUniqueId(i);
						} catch(Exception e){}
					}
					if(db.lastSize != lastSize){
						if(mailsIDsInDB.length>0){
							for(int i=length-1; i>-1; i--){
								if(mailsIDsInDB[mailsIDsInDB.length-1].equals(servList[i])){
									startNum=i;
									i=-1;
								}
							}
						}else startNum=0;
						
						ss.addLoadingString((length-startNum-1)+"  ");
						ss.addLoadingString(". ");

						for(int i=startNum; i<length && running; i++){
							String uniqueId = servList[i];
							
							ss.addLoadingString(" "+(i+1)+"  "+length+"");
							
							if(checkMessage(uniqueId, mailsIDsInDB)==-1){
								try{
									Message mes = pop.getMessage(i, 0);
									String spam = mes.getHeaderValue("X-spam");
									if(!db.antispam) spam=null;
									if(spam==null || spam.toUpperCase().equals("NOT DETECTED")){
										if(db.saveInboxMessages)addMessageToDB(inboxFolder, mes, uniqueId);
										addMessageToList(mes, pc.getPage(0), "");
									}else{
										ss.addLoadingString("  - "+(i+1));
									}
								}catch(Exception e){
								 	pc.getPage(0).textlist.deleteItem(0);
									ss.addLoadingString("  . "+(i+1)+" ");
									System.out.println(": "+e.getMessage());
								}
							}
						}
						bytesIn  += pop.getBytesIn();
						bytesOut += pop.getBytesOut();
						display.setCurrent(pc);
						pc.updateBody();
						pc.updateHeader();
						mailsIDsInDB = db.getMailsIDs(inboxFolder);
						if(running){
							db.lastSize = lastSize;
							db.editMailBox(mailBoxesList.getSelectedIndex());
						}
					}else{
						mb = new MessageBox(display, pc, "", "  ", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
						mb.show();
					}
				}else if(imap != null){
					ss.addLoadingString(".  .");
					imap.open(host, port, login, pass, ssl);
					
					ss.addLoadingString(".  ");
					
					length = imap.getMessageCount();
					
					servList = new String[length];
					mailsIDsInDB = db.getMailsIDs(inboxFolder);
					
					ss.addLoadingString("0 %");
					for(int i=0; i<length && running; i++){
						ss.setLoadingString(((i*100)/length)+" %");
						try{
							servList[i] = imap.getUniqueId(i);
						} catch(Exception e){}
					}
					if(mailsIDsInDB.length>0){
						for(int i=length-1; i>-1; i--){
							if(mailsIDsInDB[mailsIDsInDB.length-1].equals(servList[i])){
								startNum=i;
								i=-1;
							}
						}
					}else startNum=0;
					
					ss.addLoadingString((length-startNum-1)+"  ");
					ss.addLoadingString(". ");

					for(int i=startNum; i<length && running; i++){
						String uniqueId = servList[i];
						
						ss.addLoadingString(" "+(i+1)+"  "+length+"");
						
						if(checkMessage(uniqueId, mailsIDsInDB)==-1){
							try{
								Message mes = imap.getHeaders(i);
								String spam = mes.getHeaderValue("X-spam");
								if(!db.antispam) spam=null;
								if(spam==null || spam.toUpperCase().equals("NOT DETECTED")){
									if(db.saveInboxMessages)addMessageToDB(inboxFolder, mes, uniqueId);
									addMessageToList(mes, pc.getPage(0), "");
								}else{
									ss.addLoadingString("  - "+(i+1));
								}
							}catch(Exception e){
							 	pc.getPage(0).textlist.deleteItem(0);
								ss.addLoadingString("  . "+(i+1)+" ");
								System.out.println(": "+e.getMessage());
							}
						}
					}
					bytesIn  += imap.getBytesIn();
					bytesOut += imap.getBytesOut();
					display.setCurrent(pc);
					pc.updateBody();
					pc.updateHeader();
					mailsIDsInDB = db.getMailsIDs(inboxFolder);
				}else if(smtp != null){
					ss.addLoadingString(".  .");
					smtp.open(host, port, login, pass, ssl);
					ss.addLoadingString("");
					if(message!=null)smtp.sendMessage(message);
					ss.addLoadingString("");
					close();
					bytesIn  += smtp.getBytesIn();
					bytesOut += smtp.getBytesOut();
					display.setCurrent(lastDisplay);
					mb = new MessageBox(display, lastDisplay, "", " ", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
					mb.show();
				}else{
					mailsIDsInDB = db.getMailsIDs(inboxFolder);
					display.setCurrent(pc);
				}
			} 
			catch (SecurityException e) {
				mb = new MessageBox(display, lastDisplay, "!", " : "+e.getMessage(), MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
				mb.show();
				close();
			} 
			catch (IOException e) {
				mb = new MessageBox(display, lastDisplay, "!", " /: "+e.getMessage(), MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
				mb.show();
				close();
			} 
			catch (MailException e) {
				mb = new MessageBox(display, lastDisplay, "!", e.getMessage(), MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
				mb.show();
				close();
			}
			running = false;
		}
		
	
		public void addNewMessage(int index){
			running = true;
			Message mes = db.getMail(inboxFolder, index);
			String uniqueId = mailsIDsInDB[index];
			ss.addLoadingString(". ");
			if(mes.getBodyLineCount()==1){
				int mesIndex = checkMessage(mailsIDsInDB[index], servList);
				if(mesIndex>-1){
					try {
						if(pop!=null){
							running = false;
							mes = pop.getMessage(mesIndex);
							
							if(db.deleteMailsFromServer) pop.removeMessage(mesIndex);
							if(db.saveInboxMessages)saveMessageAs(inboxFolder, mes, index, pop.getUniqueId(mesIndex));

							bytesIn  += pop.getBytesIn();
							bytesOut += pop.getBytesOut();
						}else if(imap!=null){
							running = false;
							mes = imap.getMessage(mesIndex);
							
							if(db.deleteMailsFromServer) imap.removeMessage(mesIndex);
							if(db.saveInboxMessages)saveMessageAs(inboxFolder, mes, index, imap.getUniqueId(mesIndex));
							
							bytesIn  += imap.getBytesIn();
							bytesOut += imap.getBytesOut();
						}
					} 
					catch (IOException e) {
						mb = new MessageBox(display, pc, "!", " \\: "+e.getMessage(), MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
						mb.show();
						mes = null;
						running = false;
					} 
					catch (MailException e) {
						mb = new MessageBox(display, pc, "!", e.getMessage(), MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
						mb.show();
						mes = null;
						running = false;
					}
				}else{
					mb = new MessageBox(display, pc, "!", "   .", MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
					mb.show();
					running = false;
					return;
				}
			}
			if(mes != null){
				running = false;
				
				pc.getPage(pc.activePage).textlist.deleteItem(pc.getPage(pc.activePage).textlist.currentItem);
				insertMessageToList(mes, pc.getPage(0), "", pc.getPage(pc.activePage).textlist.currentItem);
//				pc.updateBody();
				
				addMessageToPC(mes);
			}
			//display.setCurrent(pc);
			System.gc();
		}
		public void deleteMessage(int index){
			running = true;
			try {
				if(pop!=null){
					pop.removeMessage(index);
					bytesIn  += pop.getBytesIn();
					bytesOut += pop.getBytesOut();
				}
				else if(imap!=null){
					imap.removeMessage(index);
					bytesIn  += imap.getBytesIn();
					bytesOut += imap.getBytesOut();
				}
			} 
			catch (IOException e) {
				mb = new MessageBox(display, pc, "!", " \\: "+e.getMessage(), MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
				mb.show();
			} 
			catch (MailException e) {
				mb = new MessageBox(display, pc, "!", e.getMessage(), MessageBox.TYPE_ERROR, db.fontsize, db.height_diff);
				mb.show();
			}
			running = false;
			System.gc();
		}

		public void close(){
			running = false;
			try {
				if(pop!=null) pop.close();
				if(imap!=null) imap.close();
				if(smtp!=null) smtp.close();
			} 
			catch (IOException e) {} 
			catch (MailException e) {}
			System.gc();
		}

	}
//	===================================
	public Main(){
		display = Display.getDisplay(this);
		icons = new ImageList();
		folders = new ImageList();
		smiles = new ImageList();
		db = new Database(); 
		ss = new SplashScreen();
		pc = new PageControl();
	}

//	===================================
	private void reSetPC(){
		pc.delAllPages();
		pc.addPage("", 		inboxMenu, 	0, folders);
		pc.addPage("", 	outboxMenu, 1, folders);
		pc.addPage("", 	sentMenu, 	2, folders);
	}
	private void reLoadGraphicControls(){
		ss.setAttributes("/images/logo.png", db.height_diff, db.fontsize);
		pc.setAttributes(display, db.fontsize, db.height_diff, folders);
	}
	private void load(){
		db.load();
		try {
			icons.load("/images/icons.png", 12);
			folders.load("/images/folders.png", 15);
			smiles.load("/images/smiles.png", 16);
		} catch (IOException e){}
		pc.setPageControlListener(this);
		ss.setSSCommandListener(this);
		reLoadGraphicControls();
		ss.addLoadingString(". ");
		display.setCurrent(ss);
		//==================
		// 
		emotions = new Emotions(new String[][]{
				{":-)", ":)"},
				{":-(", ":(", ":-((", ":((", ":-(((", ":((("},
				{";-)", ";)", ";-))", ";))"},
				{":-P", ":P", ":-p", ":p", "%)"},
				{"O:-)", "O:)", "o:-)"},
				{":'(", ":\"(", ";-(", ";("},
				{"*KISSED*"},
				{":-*", ":*"},
				{":-[", ":["},
				{">:o", ">:|", ">:O", ">:0", ">:(", "*MAD*"},
				{":-X", ":X", ":-x", ":x"},
				{":-\\", ":-/", ":-|", ":|"},
				{"=-O", "WOW", "wow"},
				{":-D", ":D", ":-))))", ":))))", "*YAHOO*"},
				{":-!", ":!"},
				{"*TIRED*"},
				{"8-)", "8)", "B-)", "B)", "*COOLBOY*"},
				{"[:-}", "[:-)", "[:)"},
				{":-$", ":$"},
				{"@="},
				{"*STOP*"},
				{"*KISSING*"},
				{"]:->", ":->"},
				{"@}->--","@};-"},
				{"*THUMBS UP*"},
				{"*DRINK*", "*BEER*"},
				{"*IN LOVE*", "*HEART*"},
				{"*JOKINGLY*", ":-))", ":))", ":-)))", ":)))", "=)", "=-)"},
				}, smiles);
		//==================
		//  
		cmd_back = 			new Command("", Command.BACK, 0);
		cmd_menu = 			new Command("", Command.OK, 0);
		cmd_done = 			new Command("", Command.OK, 0);
		cmd_cancel = 		new Command("", Command.CANCEL, 1);
		cmd_send = 			new Command(" ", Command.ITEM, 1);
		cmd_save = 			new Command("", Command.ITEM, 2);
		cmd_saveAndSend = 	new Command("  ", Command.ITEM, 3);
		//==================
		//  
		ss.addLoadingString(".  ");
		menuList = new List("InetTools EMail "+VERSION, List.IMPLICIT);
		menuList.append(" ", icons.getImage(0));
		menuList.append(" ", icons.getImage(0));
		menuList.append(" ", icons.getImage(0));
		menuList.append("", icons.getImage(0));
		menuList.append(" ", icons.getImage(0));
		menuList.append("", icons.getImage(0));
		menuList.setCommandListener(this);
		//==================
		// 
		ss.addLoadingString(".  ");
		cg_fontsize = new ChoiceGroup(" ", ChoiceGroup.EXCLUSIVE);
//		cg_fontsize.append("  ", icons.getImage(0));
		cg_fontsize.append("  ", icons.getImage(0));
		cg_fontsize.append("  ", icons.getImage(0));
		cg_fontsize.append("  ", icons.getImage(0));
		if (db.fontsize == -1)  cg_fontsize.setSelectedIndex(0, true);
		else if (db.fontsize == Font.SIZE_SMALL)  cg_fontsize.setSelectedIndex(1, true);
		else if (db.fontsize == Font.SIZE_MEDIUM) cg_fontsize.setSelectedIndex(2, true);
		else if (db.fontsize == Font.SIZE_LARGE) cg_fontsize.setSelectedIndex(3, true);
		else cg_fontsize.setSelectedIndex(0, true);
		
		cg_misc = new ChoiceGroup("", ChoiceGroup.MULTIPLE);
		cg_misc.append("", null);
		cg_misc.setSelectedIndex(0, db.smiles);

		cg_showedItems = new ChoiceGroup("    : ", ChoiceGroup.MULTIPLE);
		cg_showedItems.append("", icons.getImage(0));
		cg_showedItems.append("", icons.getImage(0));
		cg_showedItems.append("", icons.getImage(0));
		cg_showedItems.append("", icons.getImage(0));
		cg_showedItems.append("", icons.getImage(0));
		cg_showedItems.append("", icons.getImage(0));
		
		cg_showedItems.setSelectedIndex(0, db.showSubject);
		cg_showedItems.setSelectedIndex(1, db.showFrom);
		cg_showedItems.setSelectedIndex(2, db.showTo);
		cg_showedItems.setSelectedIndex(3, db.showDate);
		cg_showedItems.setSelectedIndex(4, db.showSize);
		cg_showedItems.setSelectedIndex(5, db.showMailer);

		tf_heightdiff = new TextField("   :", new Integer(db.height_diff).toString(), 2, TextField.NUMERIC);

		settingsForm = new Form("");
		settingsForm.append(cg_fontsize);
		settingsForm.append(cg_misc);
		settingsForm.append(cg_showedItems);
		settingsForm.append(tf_heightdiff);
		settingsForm.addCommand(cmd_back);
		settingsForm.addCommand(cmd_done);
		settingsForm.setCommandListener(this);
		//==================
		//  
		ss.addLoadingString(".  ");
		inboxMenu = new List("", List.IMPLICIT);
		inboxMenu.append(" ", icons.getImage(0));
		inboxMenu.append("", icons.getImage(0));
		inboxMenu.append("", icons.getImage(0));
		inboxMenu.append("", icons.getImage(0));
		inboxMenu.append("  ", icons.getImage(0));
		inboxMenu.append("  ", icons.getImage(0));
		inboxMenu.append("   ", icons.getImage(0));
		inboxMenu.append("   ", icons.getImage(0));
		inboxMenu.append("   ", icons.getImage(0));
		inboxMenu.append(" ", icons.getImage(0));
		inboxMenu.addCommand(cmd_back);
		inboxMenu.setCommandListener(this);

		outboxMenu = new List("", List.IMPLICIT);
		outboxMenu.append("", icons.getImage(0));
		outboxMenu.append(" ", icons.getImage(0));
		outboxMenu.append(" ", icons.getImage(0));
		outboxMenu.append("", icons.getImage(0));
		outboxMenu.append("", icons.getImage(0));
		outboxMenu.append(" ", icons.getImage(0));
		outboxMenu.append("   ", icons.getImage(0));
		outboxMenu.append(" ", icons.getImage(0));
		outboxMenu.addCommand(cmd_back);
		outboxMenu.setCommandListener(this);
		
		sentMenu = new List("", List.IMPLICIT);
		sentMenu.append(" ", icons.getImage(0));
		sentMenu.append("  ", icons.getImage(0));
		sentMenu.append("", icons.getImage(0));
		sentMenu.append("", icons.getImage(0));
		sentMenu.append(" ", icons.getImage(0));
		sentMenu.append("   ", icons.getImage(0));
		sentMenu.append(" ", icons.getImage(0));
		sentMenu.addCommand(cmd_back);
		sentMenu.setCommandListener(this);

		messageMenu = new List("", List.IMPLICIT);
		messageMenu.append("   ", icons.getImage(0));
		messageMenu.append(" ", icons.getImage(0));
		messageMenu.append(" ", icons.getImage(0));
		messageMenu.addCommand(cmd_back);
		messageMenu.setCommandListener(this);
		//==================
		//  
		ss.addLoadingString(". ");
		String[] mailBoxes = db.getMailBoxes();
		mailBoxesList = new List(" ", List.IMPLICIT);
		for(int i=0; i<mailBoxes.length; i++) mailBoxesList.append(mailBoxes[i], icons.getImage(2));
		mailBoxesList.addCommand(cmd_menu);
		mailBoxesList.addCommand(cmd_back);
		mailBoxesList.setCommandListener(this);

		cg_inboxType = new ChoiceGroup("  ", ChoiceGroup.EXCLUSIVE);
		cg_inboxType.append("POP3", null);
		cg_inboxType.append("IMAP", null);
		if(db.usePOP) cg_inboxType.setSelectedIndex(0, true);
		else cg_inboxType.setSelectedIndex(1, true);
		
		cg_SMTPAuthSettings	= new ChoiceGroup("SMTP ", ChoiceGroup.EXCLUSIVE);
		cg_SMTPAuthSettings.append("SMTP  ", null);
		cg_SMTPAuthSettings.append("SMTP     ", null);
		cg_SMTPAuthSettings.append("SMTP     :", null);
		if(db.useSMTPAuth){
			cg_SMTPAuthSettings.setSelectedIndex(2, true);
		}else if(db.useSMTPAuthFromPOP){
			cg_SMTPAuthSettings.setSelectedIndex(1, true);
		}else{
			cg_SMTPAuthSettings.setSelectedIndex(0, true);
		}
		
		cg_mailBoxSettings = new ChoiceGroup("", ChoiceGroup.MULTIPLE);
		cg_mailBoxSettings.append("   ", null);
		cg_mailBoxSettings.append("     ", null);
		cg_mailBoxSettings.append("", null);
		cg_mailBoxSettings.setSelectedIndex(0, db.deleteMailsFromServer);
		cg_mailBoxSettings.setSelectedIndex(1, db.saveInboxMessages);
		cg_mailBoxSettings.setSelectedIndex(2, db.antispam);
		
		tf_mailBoxName 			= new TextField(" : ", "", 100, TextField.ANY);
		tf_mailBoxUserName 		= new TextField(" : ", "", 100, TextField.ANY);
		tf_mailBoxUserEMail		= new TextField("EMail : ", "", 100, TextField.URL);
		tf_mailBoxInboxServer 	= new TextField("   : ", "", 100, TextField.URL);
		tf_mailBoxInboxPort 	= new TextField("   : ", "110", 5, TextField.NUMERIC);
		tf_mailBoxInboxUserName = new TextField("   : ", "", 100, TextField.ANY);
		tf_mailBoxInboxPass 	= new TextField("   : ", "", 100, TextField.PASSWORD);
		tf_mailBoxSMTPServer 	= new TextField(" SMTP : ", "", 100, TextField.ANY);
		tf_mailBoxSMTPPort 		= new TextField(" SMTP :", "25", 5, TextField.NUMERIC);
		tf_mailBoxSMTPUserName 	= new TextField(" SMTP : ", "", 100, TextField.ANY);
		tf_mailBoxSMTPPass 		= new TextField(" SMTP : ", "", 100, TextField.PASSWORD);
		
		cg_inboxSSL = new ChoiceGroup(" ", ChoiceGroup.MULTIPLE);
		cg_inboxSSL.append("TLS", null);

		cg_smtpSSL = new ChoiceGroup(" ", ChoiceGroup.MULTIPLE);
		cg_smtpSSL.append("SSL", null);

		mailBoxSettings = new Form(" ");
		mailBoxSettings.append(tf_mailBoxName );
		mailBoxSettings.append(tf_mailBoxUserName);
		mailBoxSettings.append(tf_mailBoxUserEMail);
		mailBoxSettings.append(cg_inboxType);
//		mailBoxSettings.append(cg_inboxSSL);
		mailBoxSettings.append(tf_mailBoxInboxServer);
		mailBoxSettings.append(tf_mailBoxInboxPort);
		mailBoxSettings.append(tf_mailBoxInboxUserName);
		mailBoxSettings.append(tf_mailBoxInboxPass);
		mailBoxSettings.append(tf_mailBoxSMTPServer);
		mailBoxSettings.append(tf_mailBoxSMTPPort);
//		mailBoxSettings.append(cg_smtpSSL);
		mailBoxSettings.append(cg_SMTPAuthSettings);
		mailBoxSettings.append(tf_mailBoxSMTPUserName);
		mailBoxSettings.append(tf_mailBoxSMTPPass);
		mailBoxSettings.append(cg_mailBoxSettings);
		mailBoxSettings.addCommand(cmd_done);
		mailBoxSettings.addCommand(cmd_cancel);
		mailBoxSettings.setCommandListener(this);
		
		mailBoxOptions = new List("", List.IMPLICIT);
		mailBoxOptions.append(" ", icons.getImage(0));
		mailBoxOptions.append(" ", icons.getImage(0));
		mailBoxOptions.append(" ", icons.getImage(0));
		mailBoxOptions.append("  ", icons.getImage(0));
		mailBoxOptions.append("  ", icons.getImage(0));
		mailBoxOptions.append(" ", icons.getImage(0));
		mailBoxOptions.addCommand(cmd_back);
		mailBoxOptions.setCommandListener(this);
		//==================
		//  
		ss.addLoadingString(".  ");
		String[] users = db.getUsersFromAdrBook();
		adrBookList = new List(" ", List.IMPLICIT);
		for(int i=0; i<users.length; i++) adrBookList.append(users[i], icons.getImage(1));
		adrBookList.addCommand(cmd_menu);
		adrBookList.addCommand(cmd_back);
		adrBookList.setCommandListener(this);

		adrBookOptions = new List("", List.IMPLICIT);
		adrBookOptions.append(" ", icons.getImage(0));
		adrBookOptions.append(" ", icons.getImage(0));
		adrBookOptions.append(" ", icons.getImage(0));
		adrBookOptions.append(" ", icons.getImage(0));
		adrBookOptions.addCommand(cmd_back);
		adrBookOptions.setCommandListener(this);

		tf_adrBookUserName 	= new TextField(": ", "", 100, TextField.ANY); 
		tf_adrBookUserEMail = new TextField("EMail: ", "", 100, TextField.URL); 
		
		adrBookrecordSettings = new Form("");
		adrBookrecordSettings.append(tf_adrBookUserName);
		adrBookrecordSettings.append(tf_adrBookUserEMail);
		adrBookrecordSettings.addCommand(cmd_done);
		adrBookrecordSettings.addCommand(cmd_back);
		adrBookrecordSettings.setCommandListener(this);
		//==================
		//    
		si_from			= new StringItem(": ", "");
		tf_topic 		= new TextField(": ", "", 100, TextField.ANY); 
		tf_email 		= new TextField("", "", 1000, TextField.URL); 
		tf_messageText 	= new TextField(" : ", "", 10000, TextField.ANY); 

		cg_addressOptions = new ChoiceGroup(": ", ChoiceGroup.EXCLUSIVE);
		cg_addressOptions.append("   ", null);
		cg_addressOptions.append(" ,  : ", null);
		cg_addressOptions.setSelectedIndex(1, true);

		mailEditForm = new Form("");
		mailEditForm.append(si_from);
		mailEditForm.append(tf_topic);
		mailEditForm.append(cg_addressOptions);
		mailEditForm.append(tf_email);
		mailEditForm.append(tf_messageText);
		mailEditForm.addCommand(cmd_save);
		mailEditForm.addCommand(cmd_send);
		mailEditForm.addCommand(cmd_saveAndSend);
		mailEditForm.addCommand(cmd_cancel);
		mailEditForm.setCommandListener(this);
		mailEditForm.setItemStateListener(this);
		//==================
		// TextBox 
		textbox  = new TextBox(null, null, 1000, TextField.URL);
		textbox.addCommand(cmd_done);
		textbox.addCommand(cmd_cancel);
		textbox.setCommandListener(this);
		//==================
		display.setCurrent(menuList);
	}
//	===================================
	protected void startApp() throws MIDletStateChangeException {
		load();
	}

	protected void pauseApp() {
	}

	protected void destroyApp(boolean lfag) throws MIDletStateChangeException {
		if(mailclient.running){
			db.lastSize = 0;
			db.editMailBox(mailBoxesList.getSelectedIndex());
		}
		if(mailclient!=null) mailclient.close();
	}

//	===================================
	private void refreshMailboxesList(){
		int size = mailBoxesList.size();
		for(int i=0; i<size; i++) mailBoxesList.delete(0);
		String[] mailBoxes = db.getMailBoxes();
		for(int i=0; i<mailBoxes.length; i++) mailBoxesList.append(mailBoxes[i], icons.getImage(2));
	}
	private void refreshAdrBookRecordsList(){
		int size = adrBookList.size();
		for(int i=0; i<size; i++) adrBookList.delete(0);
		String[] users = db.getUsersFromAdrBook();
		for(int i=0; i<users.length; i++) adrBookList.append(users[i], icons.getImage(1));
	}
	private void resetMailEditFormItems(){
		db.setMailBox(mailBoxesList.getSelectedIndex());
		si_from.setText(db.userName+" <"+db.userEMail+">");
		tf_email.setString("");
		tf_topic.setString("");
		tf_messageText.setString("");
		cg_addressOptions.setSelectedIndex(1, true);
	}
	//FIXME 
	private void setMailEditFormItems(Message mes){
		db.setMailBox(mailBoxesList.getSelectedIndex());
		si_from.setText(db.userName+" <"+db.userEMail+">");
		tf_email.setString(mes.getHeaderValue("To"));
		tf_topic.setString(mes.getHeaderValue("Subject"));

		int size = mes.getBodyLineCount();
		String s="";
		for(int i=0; i<size; i++) s+=mes.getBodyLine(i)+"\n";
		
		tf_messageText.setString(s);
		cg_addressOptions.setSelectedIndex(1, true);
	}
	private void resetmailBoxSettingsItems(){
		tf_mailBoxName.setString("");
		tf_mailBoxUserName.setString("");
		tf_mailBoxUserEMail.setString("");
		tf_mailBoxInboxServer.setString("");
		tf_mailBoxInboxPort.setString("110");
		tf_mailBoxInboxUserName.setString("");
		tf_mailBoxInboxPass.setString("");
		tf_mailBoxSMTPServer.setString("");
		tf_mailBoxSMTPPort.setString("25");
		tf_mailBoxSMTPUserName.setString("");
		tf_mailBoxSMTPPass.setString("");

		cg_inboxSSL.setSelectedIndex(0, false);
		cg_smtpSSL.setSelectedIndex(0, false);
		cg_SMTPAuthSettings.setSelectedIndex(0, true);
		cg_mailBoxSettings.setSelectedIndex(0, false);
	}
//	===================================
	public void commandAction(Command cmd, Displayable disp) {
		lastDisplay = disp;
		String 	outboxFolder = "",
				inboxFolder = "",
				sentFolder = "";
		
		if(mailBoxesList.size()>0){
			outboxFolder = "outbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			inboxFolder  = "inbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
			sentFolder   = "sent-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
		}

		if(cmd == List.SELECT_COMMAND){
			if(disp == menuList){
				String item = menuList.getString(menuList.getSelectedIndex());
				
				if(item.equals(" ")){
					if(db.getMailBoxes().length == 0){
						display.setCurrent(mailBoxSettings);
					}else display.setCurrent(mailBoxesList);
				}else if(item.equals(" ")){
					display.setCurrent(settingsForm);
				}else if(item.equals(" ")){
					display.setCurrent(adrBookList);
				}else if(item.equals("")){
					mb = new MessageBox(display, menuList, "", ": "+Utils.getKBytes(bytesIn)+" "+"\n: "+Utils.getKBytes(bytesOut)+" "+"\n: "+Utils.getKBytes(bytesIn+bytesOut)+" ", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
					mb.show();
				}else if(item.equals(" ")){
					mb = new MessageBox(display, menuList, " ", "     E-mail ( : E-mail -   ).\n     .\n C , XAOC.", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
					mb.show();
				}else if(item.equals("")){
					try {
						destroyApp(true);
					} catch (MIDletStateChangeException msce) {}
					notifyDestroyed();
				}
			}else if(disp == mailBoxesList){
				commandAction(cmd_menu, mailBoxesList);
			}else if(disp == mailBoxOptions){
				String item = mailBoxOptions.getString(mailBoxOptions.getSelectedIndex());
				
				if(item.equals(" ")){
					menuList.addCommand(cmd_back);
					display.setCurrent(pc);
					db.setMailBox(mailBoxesList.getSelectedIndex());
					if(db.usePOP){
						mailclient = new MailClient(true, db.inboxServer, db.inboxPort, db.inboxUserName, db.inboxPass, db.inboxSSL);
//						mailclient.pop.setDebug(true);
						mailclient.start();
					}else{
						mailclient = new MailClient(false, db.inboxServer, db.inboxPort, db.inboxUserName, db.inboxPass, db.inboxSSL);
//						mailclient.imap.setDebug(true);
						mailclient.start();
					}
				}else if(item.equals(" ")){
					resetMailEditFormItems();
					display.setCurrent(mailEditForm);
				}else if(item.equals(" ")){
					mailclient = new MailClient();
					mailclient.start();
				}else if(item.equals("  ")){
					edited = false;
					resetmailBoxSettingsItems();					
					display.setCurrent(mailBoxSettings);
				}else if(item.equals("  ")){
					if(mailBoxesList.size()>0){
						edited = true;
						db.setMailBox(mailBoxesList.getSelectedIndex());
						
						tf_mailBoxName.setString(db.mailboxName);
						tf_mailBoxUserName.setString(db.userName);
						tf_mailBoxUserEMail.setString(db.userEMail);
						tf_mailBoxInboxServer.setString(db.inboxServer);
						tf_mailBoxInboxPort.setString(new Integer(db.inboxPort).toString());
						tf_mailBoxInboxUserName.setString(db.inboxUserName);
						tf_mailBoxInboxPass.setString(db.inboxPass);
						tf_mailBoxSMTPServer.setString(db.smtpServer);
						tf_mailBoxSMTPPort.setString(new Integer(db.smtpPort).toString());
						tf_mailBoxSMTPUserName.setString(db.smtpUserName);
						tf_mailBoxSMTPPass.setString(db.smtpPass);

						if(db.usePOP) cg_inboxType.setSelectedIndex(0, true);
						else cg_inboxType.setSelectedIndex(1, true);

						if(db.useSMTPAuth){
							cg_SMTPAuthSettings.setSelectedIndex(2, true);
						}else if(db.useSMTPAuthFromPOP){
							cg_SMTPAuthSettings.setSelectedIndex(1, true);
						}else{
							cg_SMTPAuthSettings.setSelectedIndex(0, true);
						}
						
						if(db.inboxSSL) cg_inboxSSL.setSelectedIndex(0, true);
						if(db.smtpSSL) cg_smtpSSL.setSelectedIndex(0, true);
						
						cg_mailBoxSettings.setSelectedIndex(0, db.deleteMailsFromServer);
						cg_mailBoxSettings.setSelectedIndex(1, db.saveInboxMessages);
						cg_mailBoxSettings.setSelectedIndex(2, db.antispam);
					}

					display.setCurrent(mailBoxSettings);
				}else if(item.equals(" ")){
					if(mailBoxesList.size()>0){
						db.deleteMailBox(mailBoxesList.getSelectedIndex());
						refreshMailboxesList();
					}
					display.setCurrent(mailBoxesList);
				}
			}else if(disp == adrBookList){
				if(addAddressMode){
					addAddressMode = false;
					db.setUserFromAdrBook(adrBookList.getSelectedIndex());
					if(tf_email.getString().equals("")){
						tf_email.setString(db.adrBookUserEMail);
					}else{
						tf_email.setString(tf_email.getString()+", "+db.adrBookUserEMail);
					}
					display.setCurrent(mailEditForm);
				}else{
					commandAction(cmd_menu, adrBookList);
				}
			}else if(disp == adrBookOptions){
				String item = adrBookOptions.getString(adrBookOptions.getSelectedIndex());
				
				if(item.equals(" ")){
					if(adrBookList.size()>0){
						backToAdrBookList = true;
						resetMailEditFormItems();
						db.setUserFromAdrBook(adrBookList.getSelectedIndex());
						tf_email.setString(db.adrBookUserEMail);
						display.setCurrent(mailEditForm);
					}else{
						mb = new MessageBox(display, pc, "!", " .", MessageBox.TYPE_WARNING, db.fontsize, db.height_diff);
						mb.show();
					}
				}else if(item.equals(" ")){
					edited = false;
					tf_adrBookUserName.setString(" ");
					tf_adrBookUserEMail.setString(" ");
					display.setCurrent(adrBookrecordSettings);
				}else if(item.equals(" ")){
					if(adrBookList.size()>0){
						edited = true;
						db.setUserFromAdrBook(adrBookList.getSelectedIndex());

						tf_adrBookUserName.setString(db.adrBookUserName);
						tf_adrBookUserEMail.setString(db.adrBookUserEMail);
						}
					display.setCurrent(adrBookrecordSettings);
				}else if(item.equals(" ")){
					if(adrBookList.size()>0){
						db.deleteUserFromAdrBook(adrBookList.getSelectedIndex());
						refreshAdrBookRecordsList();
					}
					display.setCurrent(adrBookList);
				}
			}else if(disp == inboxMenu){
				String item = inboxMenu.getString(inboxMenu.getSelectedIndex());
				int mesIndex =  pc.getPage(pc.activePage).textlist.items.size() - pc.getPage(pc.activePage).textlist.currentItem-1;
				
				if(item.equals("")){
					mailclient.close();
					Message mes = db.getMail(inboxFolder, pc.getPage(pc.activePage).textlist.items.size()-pc.getPage(pc.activePage).textlist.currentItem-1, 0); 

					resetMailEditFormItems();
					tf_topic.setString(" : "+Decoder.decode(mes.getHeaderValue("Subject")));
					tf_email.setString(Decoder.decode(mes.getHeaderValue("From")));
					
					display.setCurrent(mailEditForm);
				}else if(item.equals(" ")){
					display.setCurrent(pc);
					this.onEnter(pc);
				}else if(item.equals("")){
					mailclient.close();
					Message mes = db.getMail(inboxFolder, pc.getPage(pc.activePage).textlist.items.size()-pc.getPage(pc.activePage).textlist.currentItem-1);
					MimeDecoder md = new MimeDecoder(mes);
					String text="";
					int size = mes.getBodyLineCount();

					resetMailEditFormItems();
					tf_topic.setString(" : "+Decoder.decode(mes.getHeaderValue("Subject")));
					tf_email.setString(Decoder.decode(mes.getHeaderValue("From")));
					
					text+=" :\r\n";
					for(int i=0; i<size; i++){
						text+=" >"+ (mes.getBodyLine(i).length()==0 ? "\r\n" : Decoder.decode(mes.getBodyLine(i), md.getCharset(), md.getEncoding())+"\n");
					}
					text+="\r\n";
					text+="=============================";
					text+="\r\n";
					tf_messageText.setString(text);
					
					
					display.setCurrent(mailEditForm);
				}else if(item.equals("")){
					mailclient.close();
					Message mes = db.getMail(inboxFolder, pc.getPage(pc.activePage).textlist.items.size()-pc.getPage(pc.activePage).textlist.currentItem-1);
					MimeDecoder md = new MimeDecoder(mes);
					String text="";
					int size = mes.getBodyLineCount();

					resetMailEditFormItems();
					tf_topic.setString(Decoder.decode(mes.getHeaderValue("Subject")));
					
					for(int i=0; i<size; i++){
						text+=Decoder.decode(mes.getBodyLine(i), md.getCharset(), md.getEncoding())+"\n";
					}
					tf_messageText.setString(text);
					
					
					display.setCurrent(mailEditForm);
				}else if(item.equals("  ")){
					if(!mailclient.running){
						mailclient.deleteMessage(mesIndex);
					}else{
						mb = new MessageBox(display, pc, "", "    .\n  .", MessageBox.TYPE_WARNING, db.fontsize, db.height_diff);
						mb.show();
					}
					display.setCurrent(pc);
				}else if(item.equals("  ")){
					deleteMessage(inboxFolder, mesIndex);
					pc.getPage(pc.activePage).textlist.deleteItem(pc.getPage(pc.activePage).textlist.currentItem);
					pc.updateBody();
					display.setCurrent(pc);
					db.lastSize = 0;
					db.editMailBox(mailBoxesList.getSelectedIndex());
				}else if(item.equals("   ")){
					if(!mailclient.running){
						display.setCurrent(pc);

						int size = servList.length;
						for(int i=0; i<size; i++) mailclient.deleteMessage(i);
					}else{
						mb = new MessageBox(display, pc, "", "    .\n  .", MessageBox.TYPE_WARNING, db.fontsize, db.height_diff);
						mb.show();
					}
		//FIXME    
				}else if(item.equals("   ")){
					pc.getPage(pc.activePage).textlist.clear();
					pc.getPage(pc.activePage).title = ": 0";
					db.deleteFolder(inboxFolder);
					display.setCurrent(pc);
					pc.repaint();
				}else if(item.equals("   ")){
					display.setCurrent(menuList);
				}else if(item.equals(" ")){
					mailclient.close();
					menuList.removeCommand(cmd_back);
					mb = new MessageBox(display, menuList, "", " ", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
					mb.show();
				}
			}else if(disp == outboxMenu){
				String 	item = outboxMenu.getString(outboxMenu.getSelectedIndex());
				int mesIndex =  pc.getPage(pc.activePage).textlist.items.size() - pc.getPage(pc.activePage).textlist.currentItem-1;
				
				if(item.equals("")){
					Message mes = getMessageFromDB(outboxFolder, mesIndex); 
					mailclient = new MailClient(db.smtpServer, db.smtpPort, db.smtpUserName, db.smtpPass, mes, db.smtpSSL);
//					mailclient.smtp.setDebug(true);
					mailclient.start();
					addMessageToList(mes, pc.getPage(2), "");
					pc.getPage(pc.activePage).textlist.deleteItem(pc.getPage(pc.activePage).textlist.currentItem);
					db.deleteMail(outboxFolder, mesIndex);
				}else if(item.equals(" ")){
					int size = db.getMailsIDs(outboxFolder).length,
						i = 0;
					Message mes;
					
					while(i<size){
						if(!mailclient.running){
							mes = getMessageFromDB(outboxFolder, mesIndex); 
							mailclient = new MailClient(db.smtpServer, db.smtpPort, db.smtpUserName, db.smtpPass, mes, db.smtpSSL);
//							mailclient.smtp.setDebug(true);
							mailclient.start();
							addMessageToList(mes, pc.getPage(2), "");
							pc.getPage(pc.activePage).textlist.deleteItem(pc.getPage(pc.activePage).textlist.currentItem);
							db.deleteMail(outboxFolder, mesIndex);
							
							i++;
						}else{
							mb = new MessageBox(display, pc, "", "    .\n  .", MessageBox.TYPE_WARNING, db.fontsize, db.height_diff);
							mb.show();
						}
					}
					
				}else if(item.equals(" ")){
					resetMailEditFormItems();
					display.setCurrent(mailEditForm);
				}else if(item.equals("")){
					setMailEditFormItems(getMessageFromDB(outboxFolder, mesIndex));
					display.setCurrent(mailEditForm);
				}else if(item.equals("")){
					deleteMessage(outboxFolder, mesIndex);
					pc.getPage(pc.activePage).textlist.deleteItem(pc.getPage(pc.activePage).textlist.currentItem);
					display.setCurrent(pc);
				}else if(item.equals(" ")){
					pc.getPage(pc.activePage).textlist.clear();
					db.deleteFolder(outboxFolder);
					display.setCurrent(pc);
				}else if(item.equals("   ")){
					display.setCurrent(menuList);
				}else if(item.equals(" ")){
					mailclient.close();
					menuList.removeCommand(cmd_back);
					mb = new MessageBox(display, menuList, "", " ", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
					mb.show();
				}
			}else if(disp == sentMenu){
				String item = sentMenu.getString(sentMenu.getSelectedIndex());
				int mesIndex =  pc.getPage(pc.activePage).textlist.items.size() - pc.getPage(pc.activePage).textlist.currentItem-1;
				
				if(item.equals(" ")){
					Message mes = getMessageFromDB(sentFolder, mesIndex); 
					mailclient = new MailClient(db.smtpServer, db.smtpPort, db.smtpUserName, db.smtpPass, mes, db.smtpSSL);
//					mailclient.smtp.setDebug(true);
					mailclient.start();
				}else if(item.equals("  ")){
					int size = db.getMailsIDs(sentFolder).length,
					i = 0;
				Message mes;
				
				while(i<size){
					if(!mailclient.running){
						mes = getMessageFromDB(sentFolder, mesIndex); 
						mailclient = new MailClient(db.smtpServer, db.smtpPort, db.smtpUserName, db.smtpPass, mes, db.smtpSSL);
//						mailclient.smtp.setDebug(true);
						mailclient.start();
						
						i++;
					}else{
						mb = new MessageBox(display, pc, "", "    .\n  .", MessageBox.TYPE_WARNING, db.fontsize, db.height_diff);
						mb.show();
					}
				}
				}else if(item.equals("")){
					setMailEditFormItems(getMessageFromDB(sentFolder, mesIndex));
					display.setCurrent(mailEditForm);
				}else if(item.equals("")){
					deleteMessage(sentFolder, pc.getPage(pc.activePage).textlist.currentItem);
					pc.getPage(pc.activePage).textlist.deleteItem(pc.getPage(pc.activePage).textlist.currentItem);
					display.setCurrent(pc);
				}else if(item.equals(" ")){
					pc.getPage(pc.activePage).textlist.clear();
					db.deleteFolder(sentFolder);
					display.setCurrent(pc);
				}else if(item.equals("   ")){
					display.setCurrent(menuList);
				}else if(item.equals(" ")){
					mailclient.close();
					menuList.removeCommand(cmd_back);
					mb = new MessageBox(display, menuList, "", " ", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
					mb.show();
				}
			}else if(disp == messageMenu){
				String item = messageMenu.getString(messageMenu.getSelectedIndex());
				
				if(item.equals("   ")){
					display.setCurrent(menuList);
				}else if(item.equals(" ")){
					mailclient.close();
					menuList.removeCommand(cmd_back);
					mb = new MessageBox(display, menuList, "", " ", MessageBox.TYPE_INFO, db.fontsize, db.height_diff);
					mb.show();
				}else if(item.equals(" ")){
					pc.delPage(pc.activePage);
					pc.updateBody();
					pc.updateHeader();
					display.setCurrent(pc);
				}
			}
		}else if(cmd == cmd_back){
			if(disp == settingsForm){
				display.setCurrent(menuList);
			}else if(disp == mailBoxesList){
				display.setCurrent(menuList);
			}else if(disp == mailBoxOptions){
				display.setCurrent(mailBoxesList);
			}else if(disp == adrBookList){
				if(addAddressMode)display.setCurrent(mailEditForm);
				else display.setCurrent(menuList);
			}else if(disp == adrBookOptions){
				display.setCurrent(adrBookList);
			}else if(disp == adrBookrecordSettings){
				display.setCurrent(adrBookList);
			}else if(disp == menuList){
				display.setCurrent(pc);
			}else if(disp == inboxMenu || disp == outboxMenu || disp == sentMenu || disp == messageMenu){
				display.setCurrent(pc);
			}
		}else if(cmd == cmd_done){
			if(disp == settingsForm){
				if(cg_fontsize.isSelected(0)) db.fontsize = -1;
				else if(cg_fontsize.isSelected(1)) db.fontsize = Font.SIZE_SMALL;
				else if(cg_fontsize.isSelected(2)) db.fontsize = Font.SIZE_MEDIUM;
				else if(cg_fontsize.isSelected(3)) db.fontsize = Font.SIZE_LARGE;
				
				db.smiles = cg_misc.isSelected(0);
				
				db.showSubject = cg_showedItems.isSelected(0);
				db.showFrom = cg_showedItems.isSelected(1);
				db.showTo = cg_showedItems.isSelected(2);
				db.showDate = cg_showedItems.isSelected(3);
				db.showSize = cg_showedItems.isSelected(4);
				db.showMailer = cg_showedItems.isSelected(5);
				
				db.height_diff = Utils.parseInt(tf_heightdiff.getString());
				
				db.saveAdvanced();
				reLoadGraphicControls();
				display.setCurrent(menuList);
			}else if(disp == mailBoxSettings){
				if (tf_mailBoxName.getString().equals("") || tf_mailBoxUserName.getString().equals("") || tf_mailBoxUserEMail.getString().equals("") || tf_mailBoxInboxServer.getString().equals("") || tf_mailBoxSMTPServer.getString().equals("") || tf_mailBoxInboxUserName.getString().equals("") || tf_mailBoxInboxPass.getString().equals("")) {
					Alert a = new Alert("", "    ", null, AlertType.WARNING);
					a.setTimeout(Alert.FOREVER);
					display.setCurrent(a);
					return;
				}
				db.mailboxName = tf_mailBoxName.getString();
				db.userName = tf_mailBoxUserName.getString();
				db.userEMail = tf_mailBoxUserEMail.getString();
				db.inboxServer = tf_mailBoxInboxServer.getString();
				db.inboxPort = Utils.parseInt(tf_mailBoxInboxPort.getString());
				db.inboxUserName = tf_mailBoxInboxUserName.getString();
				db.inboxPass = tf_mailBoxInboxPass.getString();
				db.smtpServer = tf_mailBoxSMTPServer.getString();
				db.smtpPort = Utils.parseInt(tf_mailBoxSMTPPort.getString());
				db.smtpUserName = tf_mailBoxSMTPUserName.getString();
				db.smtpPass = tf_mailBoxSMTPPass.getString();

				if( cg_inboxType.isSelected(0)) db.usePOP = true;
				else db.usePOP = false;

				if(cg_SMTPAuthSettings.isSelected(0)){
					db.useSMTPAuth = false;
					db.useSMTPAuthFromPOP = false;
				}else if(cg_SMTPAuthSettings.isSelected(1)){
					db.useSMTPAuth = false;
					db.useSMTPAuthFromPOP = true;
				}else{
					db.useSMTPAuth = true;
					db.useSMTPAuthFromPOP = false;
				}

				if( cg_inboxSSL.isSelected(0)) db.inboxSSL = true;
				else db.inboxSSL = false;
				if( cg_smtpSSL.isSelected(0)) db.smtpSSL = true;
				else db.smtpSSL = false;
				
				db.deleteMailsFromServer = cg_mailBoxSettings.isSelected(0);
				db.saveInboxMessages = cg_mailBoxSettings.isSelected(1);
				db.antispam = cg_mailBoxSettings.isSelected(2);

				if(edited) db.editMailBox(mailBoxesList.getSelectedIndex());
				else db.addMailBox();

				refreshMailboxesList();

				display.setCurrent(mailBoxesList);
			}else if(disp == adrBookrecordSettings){
				if (tf_adrBookUserName.getString().equals("") || tf_adrBookUserEMail.getString().equals("")) {
					Alert a = new Alert("", "    ", null, AlertType.WARNING);
					a.setTimeout(Alert.FOREVER);
					display.setCurrent(a);
					return;
				}

				db.adrBookUserName 	= tf_adrBookUserName.getString();
				db.adrBookUserEMail = tf_adrBookUserEMail.getString();
				
				if(edited) db.editUserFromAdrBook(adrBookList.getSelectedIndex());
				else db.addUserToAdrBook();

				refreshAdrBookRecordsList();
				
				display.setCurrent(adrBookList);
			}
		}else if(cmd == cmd_cancel){
			if(disp == mailBoxSettings){
				display.setCurrent(mailBoxesList);
			}else if(disp == settingsForm){
				display.setCurrent(menuList);
			}else if(disp == mailEditForm){
				addAddressMode = false;
				if(backToAdrBookList){
					backToAdrBookList = false;
					display.setCurrent(adrBookList);
				}
				else display.setCurrent(mailBoxesList);
			}
		}else if(cmd == cmd_menu){
			if(disp == mailBoxesList){
				display.setCurrent(mailBoxOptions);
			}else if(disp == adrBookList){
				if(!addAddressMode)display.setCurrent(adrBookOptions);
			}
		}else if(cmd == cmd_send){
			Message mes = new Message(si_from.getText(), tf_email.getString(), Decoder.encode(tf_topic.getString(), true));
			String body = Decoder.encode(tf_messageText.getString(), false);
			mes.size = Utils.getKBytes(body.length())+" ";
			
			mes.addHeaderLine("X-mailer: InetTools EMail "+VERSION);
			mes.addHeaderLine("Content-Type: text/plain; charset=UTF-8");
			mes.addHeaderLine("Content-Transfer-Encoding: quoted-printable");

			String[] bodyLines = Utils.splitMessageString(body);
			for(int i=0; i< bodyLines.length; i++)
				mes.addBodyLine(bodyLines[i]+"\r\n");

			mailclient = new MailClient(db.smtpServer, db.smtpPort, db.smtpUserName, db.smtpPass, mes, db.smtpSSL);
//			mailclient.smtp.setDebug(true);
			mailclient.start();
		}else if(cmd == cmd_save){
			db.getMailsIDs(outboxFolder);
			Message mes = new Message(si_from.getText(), tf_email.getString(), Decoder.encode(tf_topic.getString(), true));
			String body = Decoder.encode(tf_messageText.getString(), false);
			mes.size = Utils.getKBytes(body.length())+" ";
			
			String[] bodyLines = Utils.splitMessageString(body);
			for(int i=0; i< bodyLines.length; i++)
				mes.addBodyLine(bodyLines[i]+"\r\n");

			mes.addHeaderLine("X-mailer: InetTools EMail "+VERSION);
			mes.addHeaderLine("Content-Type: text/plain; charset=UTF-8");
			mes.addHeaderLine("Content-Transfer-Encoding: quoted-printable");

			addMessageToDB(outboxFolder, mes, "0");
			if(mailclient!=null)addMessageToList(mes, pc.getPage(1), "");
			display.setCurrent(adrBookList);
		}else if(cmd == cmd_saveAndSend){
			db.getMailsIDs(sentFolder);
			Message mes = new Message(si_from.getText(), tf_email.getString(), Decoder.encode(tf_topic.getString(), true));
			String body = Decoder.encode(tf_messageText.getString(), false);
			mes.size = Utils.getKBytes(body.length())+" ";
			
			String[] bodyLines = Utils.splitMessageString(body);
			for(int i=0; i< bodyLines.length; i++)
				mes.addBodyLine(bodyLines[i]+"\r\n");

			mes.addHeaderLine("X-mailer: InetTools EMail "+VERSION);
			mes.addHeaderLine("Content-Type: text/plain; charset=UTF-8");
			mes.addHeaderLine("Content-Transfer-Encoding: quoted-printable");

			addMessageToDB(sentFolder, mes, "0");
			if(mailclient!=null)addMessageToList(mes, pc.getPage(2), "");
			commandAction(cmd_send, null);
		}
	}
//	===================================
	public void itemStateChanged(Item item) {
		if(item == cg_addressOptions){
			if(cg_addressOptions.getString(cg_addressOptions.getSelectedIndex()).equals("   ")){
				addAddressMode = true;
				display.setCurrent(adrBookList);
				cg_addressOptions.setSelectedIndex(1, true);
			}
		}
	}
//===================================
	public void onKeyPress(PageControl sender, int keyCode) {
	}
	public void onEnter(PageControl sender) {
		int mesIndex =  sender.getPage(sender.activePage).textlist.items.size() - sender.getPage(sender.activePage).textlist.currentItem-1;
		if(sender.getPage(sender.activePage).textlist.items.size()>0){
			if(sender.activePage == 0){
				if(!mailclient.running){
					mailclient.addNewMessage(mesIndex);
				}
			}else if(sender.activePage == 1){
				String outboxFolder = "outbox-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
				addMessageToPC(db.getMail(outboxFolder, mesIndex));
			}else if(sender.activePage == 2){
				String sentFolder = "sent-"+mailBoxesList.getString(mailBoxesList.getSelectedIndex());
				addMessageToPC(db.getMail(sentFolder, mesIndex));
			}
		}
	}
	public void onUp(PageControl sender) {
	}
	public void onDown(PageControl sender) {
	}
	public void onLeft(PageControl sender) {
	}
	public void onRight(PageControl sender) {
	}
// ===========   \ 
	private void loadAndAddMailsListFromDB(String folderName, Page page, String pageTitle){
		int size = db.getMailsIDs(folderName).length;
		Message mes;
		ss.addLoadingString("0 %");
		for(int i=0; i<size; i++){
			ss.setLoadingString(((i*100)/size)+" %");
			try{
			mes = db.getMail(folderName, i, 2);
			addMessageToList(mes, page, pageTitle);
			mes = null;
			}catch(Exception e){
				ss.addLoadingString("  . "+(i+1)+" ");
				ss.addLoadingString("0 %");
			}
		}
		ss.setLoadingString("100 %");
	}
	private void addMessageToDB(String folderName, Message mes, String uniqueId){
		db.addMail(folderName, mes, uniqueId);
	}
	private void insertMessageToList(Message mes, Page page, String pageTitle, int index){
		String text = "";
		int fontStyle = Font.STYLE_PLAIN,
			fontColor = 0x000000,
			bgColor	  = 0xffffff;
		if(mes.getBodyLineCount()==1 && pageTitle.equals("")){
			page.textlist.insertImage(3, index);
			fontStyle = Font.STYLE_BOLD; 
			fontColor = 0x0000ff;
			bgColor	  = 0xffffff;
		}else page.textlist.insertImage(4, index);

		if(db.showSubject)	text+=": \""+Decoder.decode(mes.getHeaderValue("Subject"))	+"\",\n";
		if(db.showFrom)		text+=": "	+Decoder.decode(mes.getHeaderValue("From"))		+",\n";
		if(db.showTo)		text+=": "	+Decoder.decode(mes.getHeaderValue("To"))		+",\n";
		if(db.showDate)		text+=": "	+mes.getHeaderValue("Date")						+"\n";
		if(db.showSize)		text+=": "+mes.size										+"\n";
		if(db.showMailer)	text+=": "+(mes.getHeaderValue("X-mailer") != null ? mes.getHeaderValue("X-mailer"):" ");
		
		page.textlist.addText(text, fontColor, bgColor, fontStyle, db.fontsize, index);
		page.title = pageTitle+": "+page.textlist.items.size();
	}
	private void addMessageToList(Message mes, Page page, String pageTitle){
		insertMessageToList(mes, page, pageTitle, 0);
	}
	private void addMessageToPC(Message mes){
		int size = mes.getBodyLineCount();
		pc.addPage(Decoder.decode(mes.getHeaderValue("Subject")), messageMenu, 4, smiles);
		Page page = pc.getPage(pc.getSize()-1);
		String s="";
		MimeDecoder md = new MimeDecoder(mes);
		for(int i=0; i<size; i++) 
			s+=mes.getBodyLine(i).length()==0 ? "\r\n" : Decoder.decode(mes.getBodyLine(i), md.getCharset(), md.getEncoding())+"\n";
		try{
			if(db.smiles)emotions.addTextWithSmiles(page.textlist, s);
			else page.textlist.addTextWithURL(s);
		} catch(OutOfMemoryError e){
			s=null;
			pc.showPage(pc.getSize()-1);
			//display.setCurrent(pc);
			Alert a = new Alert("", " ", null, AlertType.WARNING);
			a.setTimeout(Alert.FOREVER);
			display.setCurrent(a);
			System.gc();
		}
		s=null;
		pc.showPage(pc.getSize()-1);
	}
	private String[] getMailsList(String folderName){
		return db.getMailsIDs(folderName);
	}
	private Message getMessageFromDB(String folderName, int index){
		return db.getMail(folderName, index);
	}
	private void deleteMessage(String folderName, int index){
		int size = pc.getPage(pc.activePage).textlist.items.size();
		db.deleteMail(folderName, size - index -1);
	}
	private void saveMessageAs(String folderName, Message mes, int index, String uniqueId){
		db.editMail(folderName, mes, index, uniqueId);
	}
	//===========================
	private int checkMessage(String uniqueId, String[] list){
		int size = list.length;
		
		for(int i=0; i<size; i++)if(list[i].equals(uniqueId))return i;

		return -1;
	}
	//===========================

	public void onCancel(SplashScreen sender) {
		db.lastSize = 0;
		db.editMailBox(mailBoxesList.getSelectedIndex());
		mailclient.running = false;
	}
}
