package lib.GraphicControls;

import java.io.IOException;
import java.util.Vector;

import javax.microedition.lcdui.Font;

import lib.Resources.ImageList;

public class Emotions {
	final private Vector findedEmotions = new Vector();
	final private String[][] smiles;
	public ImageList smilesList;

	public Emotions(String[][] smiles, ImageList smilesList) {
		this.smiles = smiles;
		this.smilesList = smilesList;
	}

	public Emotions(String[][] smiles, String smilesImageFileName, int smileWidth) {
		this.smiles = smiles;
		smilesList = new ImageList();
		try {
			smilesList.load(smilesImageFileName, smileWidth);
		} catch (IOException e) {}
	}

	private void findEmotionInText(String text, String emotion, int index, int startIndex){
		int findedIndex, len = emotion.length();
		
		findedIndex = text.indexOf(emotion, startIndex);
		if (findedIndex == -1) return;
		findedEmotions.addElement( new int[] {findedIndex, len, index} );
	}
	
	public void addTextWithSmiles(TextList textlist, String text, int fontColor, int bgColor, int fontStyle, int fontSize, int itemIndex){
		int startIndex = 0;
		for (;;){
			findedEmotions.removeAllElements();
			
			for (int i = 0; i < smiles.length; i++)
			for (int j = 0; j < smiles[i].length; j++)
				findEmotionInText(text, smiles[i][j], i, startIndex);  
			
			if (findedEmotions.isEmpty()) break;
			int count = findedEmotions.size();
			int minIndex = 100000, data[] = null, minArray[] = null;
			for (int i = 0; i < count; i++){
				data = (int[])findedEmotions.elementAt(i);
				if (data[0] < minIndex){
					minIndex = data[0];
					minArray = data;
				}
			}
			
			if (startIndex != minIndex)	textlist.addTextWithURL(text.substring(startIndex, minIndex), fontColor, bgColor, fontStyle, fontSize, itemIndex);
			textlist.addImage(minArray[2], itemIndex);
			startIndex = minIndex+minArray[1];
		}
		int lastIndex = text.length();
		if (lastIndex != startIndex) textlist.addTextWithURL(text.substring(startIndex, lastIndex), fontColor, bgColor, fontStyle, fontSize, itemIndex);
	}
	public void addTextWithSmiles(TextList textlist, String text){
		textlist.addItem();
		addTextWithSmiles(textlist, text, 0x000000, 0xffffff, Font.STYLE_PLAIN, textlist.fontSize, textlist.items.size()-1);
	}
}
