package lib.GraphicControls;

import java.io.IOException;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import lib.Font.SampleFont;
import lib.Utils.Utils;

public class SplashScreen extends Canvas{
	private Font font = null;
	private SampleFont sampleFont = null;;
	private Image ti;
	private Graphics tg;
	private Image IMG_LOGO, IMG_LOAD;
	private int fontHeight,
				fontSize = Font.SIZE_SMALL,
				width,
				height;
	private SplashScreenCommandListener sscl = null;
		
	private String 	loadingString  = " ",
					loadingString1 = " ",
					loadingString2 = " ";
	private progressBar pb;
	
//  =====================================
	private class progressBar extends Thread{
		public boolean loading = true;
		public Graphics temp;
		
		public progressBar(){
			IMG_LOAD = Image.createImage(26, 8);
			temp = IMG_LOAD.getGraphics();
		}
		public void run() {
			int i =0;
			while(loading){
				temp.setColor(160, 160, 160);
				temp.fillRect(0,0,26,8);
				temp.setColor(225, 225, 225);
				temp.fillRect(0,0,25,7);
				temp.setColor(212, 208, 200);
				temp.drawLine(25,0,25,1);
				temp.drawLine(0,7,1,8);
				temp.setColor(0);
				for(int j=0; j<4; j++) temp.drawRect(j*6, 0, 6, 6);
				if(i>3) i =0;
				temp.setColor(0, 150, 40);
				temp.fillRect(i*6, 0, 6, 6);
				temp.setColor(145, 220, 173);
				temp.fillRect(i*6+1, 1, 4, 4);
				temp.setColor(0, 184, 160);
				temp.fillRect(i*6+2, 2, 3, 3);
				updateProgressBar();
				i++;
				try {sleep(500);}catch (InterruptedException e){}
			}
		}
	}
//  =====================================
	public SplashScreen() {
		//FIXME
		//MIDP 2.0
		setFullScreenMode(true);
	}
//  =====================================
	public void setAttributes(String logoFilename, int heightdiff, int fontSize){
		this.fontSize= fontSize;
		pb = null;
		width = getWidth();
		height = getHeight()+heightdiff;

		if(fontSize<0){
			sampleFont = new SampleFont("/fonts/font.bin");
			fontHeight = sampleFont.height;
		}else{
			font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, fontSize);
			fontHeight = font.getHeight();
		}
		
		IMG_LOGO = loadImageFromFile(logoFilename);
		
		ti = Image.createImage(width, height);
		tg = ti.getGraphics();
		
		drawLogo();
		pb = new progressBar();
		pb.setPriority(Thread.MIN_PRIORITY);
		pb.start();
		repaint();
	}
	public void setSSCommandListener(SplashScreenCommandListener sscl){
		this.sscl = sscl;
	}
	public 	void addLoadingString(String str){
		loadingString2 = loadingString1;
		loadingString1 = loadingString;
		loadingString = str;
		
		if(fontSize<0){
			if(sampleFont.stringWidth(loadingString)>width-15){
				loadingString = Utils.splitString(loadingString, sampleFont, width-15-sampleFont.stringWidth("..."))[0];
				loadingString+="...";
			}
		}else{
			if(font.stringWidth(loadingString)>width-15){
				loadingString = Utils.splitString(loadingString, font, width-15-font.stringWidth("..."))[0];
				loadingString+="...";
			}
		}

		updateLoadingString();
	}
	public 	void setLoadingString(String str){
		loadingString = str;
		
		if(fontSize<0){
			if(sampleFont.stringWidth(loadingString)>width-15){
				loadingString = Utils.splitString(loadingString, sampleFont, width-15-sampleFont.stringWidth("..."))[0];
				loadingString+="...";
			}
		}else{
			if(font.stringWidth(loadingString)>width-15){
				loadingString = Utils.splitString(loadingString, font, width-15-font.stringWidth("..."))[0];
				loadingString+="...";
			}
		}

		updateLoadingString();
	}
//  =====================================
	private Image loadImageFromFile(String filename){
		Image temp = null;
		try{
	    	temp = Image.createImage(filename);
		}catch(IOException ioexception) { }
		return temp;
	}
	private void drawLogo(){
		tg.setColor(180, 180, 180);
		tg.drawRect(0,0,width-1, height-1);

		tg.setColor(191, 193, 208);
		tg.drawRect(1,1,width-3, height-3);
		tg.setColor(241, 241, 241);
		tg.drawRect(1,1,width-4, height-4);
		tg.setColor(219, 222, 232);
		tg.drawRect(2,2,width-5, height-5);
		tg.setColor(255, 255, 255);
		tg.drawRect(2,2,width-6, height-6);
		tg.setColor(212, 208, 200);
		tg.drawRect(3,3,width-7, height-7);

		tg.setColor(241, 243, 248);
		tg.fillRect(4,4,width-8, height-8);

		if(IMG_LOGO != null)tg.drawImage(IMG_LOGO, width/2 - IMG_LOGO.getWidth()/2, 20,0);
	}
	private	void updateLoadingString(){
		int topPos = height - 3*fontHeight - 5;

		tg.setClip(4, topPos, width-8, 3*fontHeight+1);
		tg.setColor(241, 243, 248);
		tg.fillRect(4, topPos, width-8, 2*fontHeight+4);
		tg.fillRect(4, topPos+2*fontHeight, width-IMG_LOAD.getWidth()-10, fontHeight+1);

		topPos-=2;
		if(fontSize<0){
			Utils.drawFramedText(tg, sampleFont, loadingString2, 6, topPos, 0xffffff, 0xcdcdcd);
			//============================
			topPos+=fontHeight;
			Utils.drawFramedText(tg, sampleFont, loadingString1, 6, topPos, 0xffffff, 0x909090);
			//============================
			String temp = loadingString;
			if(sampleFont.stringWidth(loadingString)>width-15-IMG_LOAD.getWidth()){
				temp = Utils.splitString(loadingString, sampleFont, width - IMG_LOAD.getWidth()-15-font.stringWidth("..."))[0];
				temp+="...";
			}

			topPos+=fontHeight;
			Utils.drawFramedText(tg, sampleFont, temp, 6, topPos, 0xffffff, 0x000000);
		}else{
			Utils.drawFramedText(tg, font, loadingString2, 6, topPos, 0xffffff, 0xcdcdcd);
			//============================
			topPos+=fontHeight;
			Utils.drawFramedText(tg, font, loadingString1, 6, topPos, 0xffffff, 0x909090);
			//============================
			String temp = loadingString;
			if(font.stringWidth(loadingString)>width-15-IMG_LOAD.getWidth()){
				temp = Utils.splitString(loadingString, font, width - IMG_LOAD.getWidth()-15-font.stringWidth("..."))[0];
				temp+="...";
			}

			topPos+=fontHeight;
			Utils.drawFramedText(tg, font, temp, 6, topPos, 0xffffff, 0x000000);
		}
		
		topPos -= 2*fontHeight+2;
		if(topPos<20+IMG_LOGO.getHeight()+5) topPos = 20+IMG_LOGO.getHeight()+7;
		repaint(4, topPos, width-8, 3*fontHeight+8);
	}
	private	void updateProgressBar(){
		tg.drawImage(IMG_LOAD, width-IMG_LOAD.getWidth()-6, height-IMG_LOAD.getHeight()-5, Graphics.LEFT | Graphics.TOP);
		repaint(width-IMG_LOAD.getWidth()-6, height-IMG_LOAD.getHeight()-5, IMG_LOAD.getWidth(), IMG_LOAD.getHeight());
	}
//  =====================================
	protected void paint(Graphics g) {
		if(isShown()) g.drawImage(ti, 0, 0, 0);
	}
	protected void keyPressed(int keyCode){
		if(keyCode == KEY_POUND || keyCode ==-7 || keyCode ==-4 || keyCode ==-12){
			if(sscl!=null) sscl.onCancel(this);
		}
	}
}
