package lib.Resources;

import java.io.IOException;
import java.util.Vector;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

public class ImageList{
	
	private Vector items = new Vector();
	private Image resImage;
	private int width = 0, 
				height = 0,
				size = 0;

	public void create(Image img, int width){
		resImage = img;
		this.width = width;
		this.height = resImage.getHeight();
		this.size = resImage.getWidth() / width;
	    for (int i = 0; i < size; i++){
		      Image newImage = Image.createImage(width, height);
		      newImage.getGraphics().drawImage(resImage, -width*i, 0, Graphics.TOP|Graphics.LEFT);
		      items.addElement( Image.createImage(newImage) );
		    }
	}

	public void load(String resName, int width) throws IOException{
		resImage = Image.createImage(resName);
		this.width = width;
		this.height = resImage.getHeight();
		this.size = resImage.getWidth() / width;
	    for (int i = 0; i < size; i++){
		      Image newImage = Image.createImage(width, height);
		      newImage.getGraphics().drawImage(resImage, -width*i, 0, Graphics.TOP|Graphics.LEFT);
		      items.addElement( Image.createImage(newImage) );
		    }
	}

	public void drawImage(Graphics g, int index, int x, int y){
		int clipX = g.getClipX(),
			clipY = g.getClipY(),
			clipWidth = g.getClipWidth(),
			clipHeight = g.getClipHeight();
		
		if(x+width>clipX && y+height>clipY && x<clipX+clipWidth && y<clipY+clipHeight){
			int	left = x>clipX ? x : clipX+1,
				top =  y>clipY ? y : clipY+1,
				width  = this.width<clipWidth   ? this.width  : clipWidth-1,
				height = this.height<clipHeight ? this.height : clipHeight-1;
			
			g.setClip(left, top, width, height);
			g.drawImage(resImage, x-index*this.width, y, Graphics.TOP|Graphics.LEFT);
			g.setClip(clipX, clipY, clipWidth, clipHeight);
		}
	}

	public Image getImage(int index){
	 	return (Image) items.elementAt(index);
	}

	public int getWidth(){
		return width;
	}
	
	public int getHeight(){
		return height;
	}
	
	public int getSize(){
		return size;
	}

	public void clear(){
		items.removeAllElements();
		resImage = null;
	}
}